// -*-C++-*- 

/*  src/containers/MutableLayeredContainer.cpp  */

/*
 * Author: Philogelos A. <Philogelos@yahoo.com>
 * Maintainer: Philogelos A.
 * Keywords: C++, library, containers
 *
 * Copyright (C) 1998, 1999 Philogelos A.
 *
 * This file is part of Quercus Robusta.
 *
 * Quercus Robusta is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this software; see the file COPYING.LIB.  If not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */



/* $Id: MutableLayeredContainer.cpp,v 1.3 1999/05/22 13:00:34 philogelos Exp $ */
#if !defined(_INLINE)
static char cvsid[] = "@(#)$Id: MutableLayeredContainer.cpp,v 1.3 1999/05/22 13:00:34 philogelos Exp $";
static char debugFileId[] = __FILE__;
#endif


#include "containers/MutableLayeredContainer.hpp"
#include "containers/MutableLayeredPosition.hpp"
#include "containers/MutablePosition.hpp"
#include "LinkManager.hpp"
#include "Debug.hpp"

MutablePositionEnumeration *MutableLayeredContainer::getMutableEnumeration() const
{
  return new MutableLayeredEnumeration( ( MutableLayeredContainer * ) this );
}

Container *MutableLayeredContainer::getBaseContainer() const
{
  return getBaseMutableContainer();
}

MutablePosition  *MutableLayeredContainer::createMutableFromBase
( MutablePosition *aBasePosition )
{
  preC_( aBasePosition != ( MutablePosition * ) NULL );
  preC_( getBaseContainer() -> isValid( aBasePosition ) );
  return new MutableLayeredPosition( this, aBasePosition );
}

boolean MutableLayeredContainer::isEmpty() const
{
  return LayeredContainer::isEmpty();
}

PositionEnumeration *MutableLayeredContainer::getEnumeration() const
{
  return LayeredContainer::getEnumeration();
}

Index MutableLayeredContainer::getCardinality() const
{
  return LayeredContainer::getCardinality();
}



MutableLayeredEnumeration::MutableLayeredEnumeration
( MutableLayeredContainer *aContainer )
{
  FNNINIT( baseContainer, aContainer );

  FINIT( baseEnum, aContainer -> getBaseMutableContainer() -> 
		 getMutableEnumeration() );
  test_( baseEnum != NIL );
}

MutableLayeredEnumeration::~MutableLayeredEnumeration()
{
  FDONE( baseEnum );
  FDONE( baseContainer );
}

MutablePosition *MutableLayeredEnumeration::getNextMutablePosition()
{
  return( baseContainer -> createMutableFromBase
		  ( baseEnum -> getNextMutablePosition() ) );
}

boolean MutableLayeredEnumeration::hasMoreElements()
{
  return( baseEnum -> hasMoreElements() );
}

#if defined(_INLINE)
#include "../src/Debug.ipp"
#endif

/* $Log: MutableLayeredContainer.cpp,v $
 * Revision 1.3  1999/05/22 13:00:34  philogelos
 * Merging sources back from SPARC
 *
 * Revision 1.2  1999/03/03 19:09:36  philogelos
 * Put sources under GNU Library License
 *
 * Revision 1.1  1999/02/28 16:30:00  philogelos
 * LayeredContainer adde. Tuned for inlines.
 * */
